package com.example.demo.core.repository;

import java.util.List;

// Интерфейс хранилища элементов
public interface CommonRepository<E, T> {
    // Получить все элементы
    List<E> getAll();

    // Получить элемент по идентификатору
    E get(T id);

    // Добавить элемент
    E create(E entity);

    // Изменить элемент
    E update(E entity);

    // Удалить элемент
    E delete(E entity);

    // Удалить все элементы
    void deleteAll();
}
