package com.example.demo.items.api;

import com.fasterxml.jackson.annotation.JsonProperty;

import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotNull;

// DTO для сущности "Заказ" (Заказ, содержащий книги) 
public class ItemDto {
    // Идентфикатор
    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Long id;

    // Идентификатор типа книги
    @NotNull
    @Min(1)
    private Long typeId;

    // Цена книги
    @NotNull
    @Min(1)
    private Double price;

    // Количество книг
    @NotNull
    @Min(1)
    private Integer count;

    // Получить идентификатор
    public Long getId() {
        return id;
    }

    // Установить идентификатор
    public void setId(Long id) {
        this.id = id;
    }

    // Получить идентификатор типа книги
    public Long getTypeId() {
        return typeId;
    }

    // Установить идентификатор типа книги
    public void setTypeId(Long typeId) {
        this.typeId = typeId;
    }

    // Получить цену книги
    public Double getPrice() {
        return price;
    }

    // Установить цену книги
    public void setPrice(Double price) {
        this.price = price;
    }

    // Получить количество книг
    public Integer getCount() {
        return count;
    }

    // Установить количество книг
    public void setCount(Integer count) {
        this.count = count;
    }

    // Получить сумму заказа
    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public Double getSum() {
        return price * count;
    }
}
