package com.example.demo.items.model;

import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.types.model.TypeEntity;

// Сущность "Заказ" (Заказ, содержащий книги) 
public class ItemEntity extends BaseEntity {
    // Тип книги
    private TypeEntity type;

    // Цена книги
    private Double price;

    // Количество книг
    private Integer count;

    // Конструктор по умолчанию
    public ItemEntity() {
        super();
    }

    // Конструктор с параметрами для создания объекта
    public ItemEntity(Long id, TypeEntity type, Double price, Integer count) {
        super(id);
        this.type = type;
        this.price = price;
        this.count = count;
    }

    // Получить тип книги
    public TypeEntity getType() {
        return type;
    }

    // Установить тип книги
    public void setType(TypeEntity type) {
        this.type = type;
    }

    // Получить стоимость книги
    public Double getPrice() {
        return price;
    }

    // Установить стоимость книги
    public void setPrice(Double price) {
        this.price = price;
    }

    // Получить количество книг
    public Integer getCount() {
        return count;
    }

    // Установить количество книг
    public void setCount(Integer count) {
        this.count = count;
    }

    // Получить хэш-код объекта
    @Override
    public int hashCode() {
        return Objects.hash(id, type, price, count);
    }

    // Сравнить объекты
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final ItemEntity other = (ItemEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getType(), type)
                && Objects.equals(other.getPrice(), price)
                && Objects.equals(other.getCount(), count);
    }
}
