package com.example.demo.messages.api;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonProperty;

import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;

// DTO для сущности "Сообщение"
public class MessageDto {
    // Идентфикатор
    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Long id;

    // Идентификатор отправителя сообщения
    @NotNull
    @Min(1)
    private Long senderId;

    // Текст сообщения
    @NotBlank
    private String text;

    // Дата отправки
    @NotBlank
    private Date date;

   // Получить идентификатор
    public Long getId() {
        return id;
    }

    // Установить идентификатор
    public void setId(Long id) {
        this.id = id;
    }

    // Получить идентификатор отправителя сообщения
    public Long getSenderId() {
        return senderId;
    }

    // Установить идентификатор отправителя сообщения
    public void setSenderId(Long senderId) {
        this.senderId = senderId;
    }

    // Получить текст сообщения
    public String getText() {
        return text;
    }

    // Установить текст сообщения
    public void setText(String text) {
        this.text = text;
    }

    // Получить дату отправления
    public Date getDate() {
        return date;
    }

    // Установить дату отправления
    public void setDate(Date date) {
        this.date = date;
    }
}
