package com.example.demo.messages.model;

import java.util.Date;
import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.users.model.UserEntity;

// Сущность "Сообщение"
public class MessageEntity extends BaseEntity {
    // Отправитель сообщения
    private UserEntity sender;

    // Текст сообщения
    private String text;

    // Дата отправки
    private Date date;

    // Конструктор по умолчанию
    public MessageEntity() {
        super();
    }

    // Конструктор с параметрами для создания объекта
    public MessageEntity(Long id, UserEntity sender, String text) {
        super(id);
        this.sender = sender;
        this.text = text;
        this.date = new Date();
    }

    // Получить отправителя
    public UserEntity getSender() {
        return sender;
    }

    // Установить отправителя
    public void setSender(UserEntity sender) {
        this.sender = sender;
    }

    // Получить текст сообщения
    public String getText() {
        return text;
    }

    // Установить текст сообщения
    public void setText(String text) {
        this.text = text;
    }

    // Получить дату отправления
    public Date getDate() {
        return date;
    }

    // Установить дату отправления
    public void setDate(Date date) {
        this.date = date;
    }

    // Получить хэш-код объекта
    @Override
    public int hashCode() {
        return Objects.hash(id, sender, text, date);
    }

    // Сравнить объекты
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final MessageEntity other = (MessageEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getSender(), sender)
                && Objects.equals(other.getText(), text)
                && Objects.equals(other.getDate(), date);
    }
}
