package com.example.demo.users.model;

import java.util.Objects;

import com.example.demo.core.model.BaseEntity;

// Сущность "Пользователь"
public class UserEntity extends BaseEntity {
    // Имя/логин пользователя
    private String username;

    // Пароль пользователя
    private String password;

    // Электронный адрес почты пользователя
    private String email;

    // Конструктор по умолчанию
    public UserEntity() {
        super();
    }

    // Конструктор с параметрами для создания объекта
    public UserEntity(Long id, String username, String password, String email) {
        super(id);
        this.username = username;
        this.password = password;
        this.email = email;
    }

    // Получить имя/логин пользователя
    public String getUsername() {
        return username;
    }

    // Установить имя/логин пользователя
    public void setUsername(String username) {
        this.username = username;
    }

    // Получить пароль пользователя
    public String getPassword() {
        return password;
    }

    // Установить пароль пользователя
    public void setPassword(String password) {
        this.password = password;
    }

    // Получить электронный адрес почты пользователя
    public String getEmail() {
        return email;
    }

    // Установить электронный адрес почты пользователя
    public void setEmail(String email) {
        this.email = email;
    }

    // Получить хэш-код объекта
    @Override
    public int hashCode() {
        return Objects.hash(id, username, password, email);
    }

    // Сравнить объекты
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final UserEntity other = (UserEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getUsername(), username)
                && Objects.equals(other.getPassword(), password)
                && Objects.equals(other.getEmail(), email);
    }
}
